<template>
    <v-container fluid fill-height>
        <v-row class="align-center justify-center">
            <v-card class="pa-4">
                <v-container class="wrapper">
                    <v-row>
                        <v-col>
                            <div class="subtitle">Holder Name</div>
                            <v-text-field
                                v-model="holder"
                                dense
                                outlined
                                hide-details
                            ></v-text-field>
                        </v-col>
                    </v-row>
                    <v-row>
                        <v-col>
                            <div class="subtitle">Client Secret</div>
                            <v-text-field
                                v-model="secret"
                                dense
                                outlined
                                hide-details
                            ></v-text-field>
                        </v-col>
                    </v-row>
                    <v-row>
                        <v-col>
                            <div class="subtitle">Credit Card</div>
                            <div id="card-element"></div>
                        </v-col>
                    </v-row>
                    <v-row>
                        <v-col>
                            <v-btn
                                @click="onClick"
                                :loading="loading"
                                class="text-capitalize"
                                color="primary"
                                block
                            >
                                Create Source
                            </v-btn>
                        </v-col>
                    </v-row>
                    <v-row>
                        <v-col class="pa-2">
                            {{ response }}
                        </v-col>
                    </v-row>
                </v-container>
            </v-card>
        </v-row>
    </v-container>
</template>

<script>
    export default {
        name: 'StripeComponent',
        props: ['stripeKey'],
        data: () => ({
            stripe: null,
            holder: '',
            secret: '',
            cardElement: null,
            style: {
                base: {
                    color: '#32325d',
                    fontFamily: '"Helvetica Neue", Helvetica, sans-serif',
                    fontSmoothing: 'antialiased',
                    fontSize: '16px',
                    '::placeholder': {
                        color: '#aab7c4'
                    }
                },
                invalid: {
                    color: '#fa755a',
                    iconColor: '#fa755a'
                }
            },
            response: null,
            loading: false
        }),
        created() {
            this.stripe = Stripe(this.stripeKey);
        },
        mounted() {
            const elements = this.stripe.elements();
            this.cardElement = elements.create('card', {style: this.style});
            this.cardElement.mount('#card-element');
        },
        methods: {
            async onClick() {
                this.loading = true;

                this.response = await this.stripe.confirmCardSetup(this.secret, {
                    payment_method: {
                        card: this.cardElement,
                        billing_details: {
                            name: this.holder,
                        },
                    },
                });

                this.loading = false;
            }
        }
    }
</script>

<style scoped>
    .wrapper {
        min-width: 300px;
    }
    .StripeElement {
        box-sizing: border-box;

        height: 40px;

        padding: 10px 12px;

        border: 1px solid rgba(0,0,0,.87);
        border-radius: 4px;
        background-color: white;

        box-shadow: 0 1px 3px 0 #EEEEEE;
        -webkit-transition: box-shadow 150ms ease;
        transition: box-shadow 150ms ease;
    }

    .StripeElement--focus {
        box-shadow: 0 1px 3px 0 #cfd7df;
    }

    .StripeElement--invalid {
        border-color: #fa755a;
    }

    .StripeElement--webkit-autofill {
        background-color: #fefde5 !important;
    }
</style>
